import tkinter as tk
import time
import random


class App(tk.Tk):
    def __init__(self):
        super().__init__()
        self.colors = [[85, 253, 253], [46, 151, 231], [62, 227, 215], [11, 83, 148], [105, 205, 175], [161, 206, 246]]
        self.color = "000000"
        self.count = 0
        self.width = 600
        self.height = 600
        self.squares_x = 10
        self.squares_y = 10
        self.squares_width = int(self.width / self.squares_x)
        self.squares_height = int(self.height / self.squares_y)
        self.canv = tk.Canvas(self, width = 600, height = 600, bg = "white")
        self.puncts = []
        self.polygons = []
        self.arcs = []
        self.squares = []
        self.canv.bind("<Button-1>", self.create_circle)
        self.canv.pack()
        for i in range((self.squares_x+1)*(self.squares_y+1)):
            self.puncts.append([(i % (self.squares_x+1) * self.squares_width), (i // (self.squares_x+1)) * self.squares_width])
        for j in range((self.squares_x+1)*(self.squares_y+1)):
            if self.puncts[j][0] < self.width and self.puncts[j][1] < self.height:
                self.polygons.append([self.canv.create_polygon(self.puncts[j][0], self.puncts[j][1], self.puncts[j+self.squares_x+2][0], self.puncts[j+self.squares_y+2][1], self.puncts[j+self.squares_x+1][0], self.puncts[j+self.squares_y+1][1], fill = "#000000"), 00.0, 00.0, 00.0, 00.0, 00.0, 00.0, 00.0, 00.0, 00.0, False, 00.0, 00.0, 00.0])
##                0 - Элемент канваса, 1, 2, 3 - текущие ложные цвета цвета rgb, 4, 5, 6 - цвета цели rgb, 7, 8, 9 - цвета шагового сдвига rgb, 10 - значение True или False белого, 11, 12, 13 - текущие настоящие цвета
                self.polygons.append([self.canv.create_polygon(self.puncts[j][0], self.puncts[j][1], self.puncts[j+self.squares_x+2][0], self.puncts[j+self.squares_y+2][1], self.puncts[j+1][0], self.puncts[j+1][1], fill = "#000000"), 00.0, 00.0, 00.0, 00.0, 00.0, 00.0, 00.0, 00.0, 00.0, False, 00.0, 00.0, 00.0])
                self.canv.update()
        for r in range(0, 180):
            for g in range(110, 255):
                for b in range(110, 255):
                    self.colors.append([r, g, b])

    def blink(self):
        for i in self.polygons:
            next_color = random.choice(self.colors)
            i[4] = next_color[0]
            i[5] = next_color[1]
            i[6] = next_color[2]
            i[7] = float(i[4]-i[1]) / 30.0
            i[8] = float(i[5]-i[2]) / 30.0
            i[9] = float(i[6]-i[3]) / 30.0

        for q in range(30):
            for i in self.polygons:
                c = self.canv.coords(i[0])
                overlapping = self.canv.find_overlapping(c[0], c[1], c[2], c[3])
                if overlapping[-1] > len(self.polygons):
                    i[10] = True
                else:
                    i[10] = False
                i[1] += i[7]
                i[2] += i[8]
                i[3] += i[9]
                if i[10]:
                    i[11] = 183.0
                    i[12] = 248.0
                    i[13] = 255.0
                else:
                    i[11] = i[1]
                    i[12] = i[2]
                    i[13] = i[3]
                self.red2 = "0"*(2-len(hex(int(i[11]))[2:]))+hex(int(i[11]))[2:]
                self.green2 = "0"*(2-len(hex(int(i[12]))[2:]))+hex(int(i[12]))[2:]
                self.blue2 = "0"*(2-len(hex(int(i[13]))[2:]))+hex(int(i[13]))[2:]
                self.color = self.red2 + self.green2 + self.blue2
                #print(self.color)
                self.canv.itemconfig(i[0], fill = "#"+self.color)
                if len(self.arcs) != 0:
                    for l in self.arcs:
                        if l[3]-l[1] < 7000:
                            l[1] -= 0.0625
                            l[2] -= 0.0625
                            l[3] += 0.0625
                            l[4] += 0.0625
                            if l[1] == float(int(l[1])):
                                self.canv.coords(l[0], l[1], l[2], l[3], l[4])
                        else:
                            self.canv.delete(l[0])
                            self.arcs.remove(l)
            self.canv.update()
        self.after(0, self.blink)
    def create_circle(self, event):
        self.arcs.append([self.canv.create_arc(event.x - 1, event.y - 1, event.x + 1, event.y + 1, start = 0, extent = 359.9999999999999, style = "arc", outline="#b7f8ff", width = 0.5), event.x-1, event.y-1, event.x+1, event.y+1])
        self.canv.update()



MyApp = App()
MyApp.blink()
MyApp.mainloop()
